﻿Imports System
Imports System.Console

Module Module_Main
    Public QQ_Number, QQ_Password, AI, CMD_Password, CMD_Head As String

    Public AI_MainClass As Type = Nothing
    Public Listening_Thread As New System.Threading.Thread(AddressOf Listening_Thread_Proc)

    Public Verify_Code, Hex_Code, Encrypt_Code As String
    Public cookies As New Net.CookieCollection
    Public Username, ptwebqq, clientId, psessionid, vfwebqq As String
    Public Friend_List As QQ_Friend_List
    Public Group_List As IDictionary(Of String, String) = New Dictionary(Of String, String)()


#Region "Functions"
    Sub Load_Configuration()
        Randomize()

        Dim Xml_Config_Doc As New Xml.XmlDocument
        Dim Xml_Config_Root As Xml.XmlNode
        Xml_Config_Doc.Load(My.Application.Info.DirectoryPath + "\Robot_Config.xml")
        Xml_Config_Root = Xml_Config_Doc.LastChild

        QQ_Number = Xml_Config_Root.SelectSingleNode("QQ").InnerText
        QQ_Password = Xml_Config_Root.SelectSingleNode("Password").InnerText
        clientId = Xml_Config_Root.SelectSingleNode("ClientID").InnerText
        AI = Xml_Config_Root.SelectSingleNode("AI").InnerText
        CMD_Password = Xml_Config_Root.SelectSingleNode("CMD_Password").InnerText
        CMD_Head = Xml_Config_Root.SelectSingleNode("CMD_Head").InnerText

        If clientId = -1 Then clientId = 800000 + Rnd() * 100000

        Try
            Dim AI_Assembly As Reflection.Assembly = Reflection.Assembly.LoadFile(My.Application.Info.DirectoryPath + "\" + AI)
            For Each MyType As Type In AI_Assembly.GetTypes()
                If MyType.Name = "WebQQ_Client" Then
                    AI_MainClass = MyType
                    Exit For
                End If
            Next
        Catch ex As Exception
            AI_MainClass = Nothing
        End Try

        If AI_MainClass Is Nothing Then WebQQ_Interface._Error("Invalid_AI")
    End Sub

    Function Check_Network() As Boolean
        If My.Computer.Network.IsAvailable = False Then WebQQ_Interface._Error("No_Internet")
        Return My.Computer.Network.IsAvailable
    End Function

    Sub Check_Verify_Code()
        On Error GoTo 1
        With Http.HttpWebResponseUtility.CreateGetHttpResponse("http://ptlogin2.qq.com/check?" + "uin=" + QQ_Number + "&appid=1003903&r=0.23301555978693034", -1, "", cookies)
            Verify_Code = New System.IO.StreamReader(.GetResponseStream()).ReadToEnd
            cookies.Add(.Cookies)
        End With
        'WriteLine("Feedback: " + Verify_Code)                     'ptui_checkVC('0','!OSC','\x00\x00\x00\x00\x5c\xa4\x73\x8a');
        Verify_Code = Verify_Code.Replace("'", Nothing)          'ptui_checkVC(0,!OSC,\x00\x00\x00\x00\x5c\xa4\x73\x8a);
        Verify_Code = Verify_Code.Replace("ptui_checkVC(", Nothing).Replace(");", Nothing) '0,!OSC,\x00\x00\x00\x00\x5c\xa4\x73\x8a
        Hex_Code = Split(Verify_Code, ",")(2).Replace("\x", Nothing).ToUpper
        If Verify_Code.StartsWith("0") Then                      'Determine whether the user need to input the verify code or not
            Verify_Code = Split(Verify_Code, ",")(1)             '!OSC
        Else
            With New Form_Verifying
                Dim TempPicFile As String = System.IO.Path.GetTempFileName()
                My.Computer.Network.DownloadFile("http://captcha.qq.com/getimage?aid=1003903&&uin=" + QQ_Number + "&vc_type=" + Split(Verify_Code, ",")(1), TempPicFile)
                .PictureBox_Valid.Image = Drawing.Image.FromFile(TempPicFile)
                If .ShowDialog <> Windows.Forms.DialogResult.OK Then End 'Refuse to input the verify code will cause crash of the program
                Verify_Code = .TextBox_Code.Text
                .Dispose()
            End With
        End If
        Exit Sub
1:
        WebQQ_Interface._Error(Err.Description)
    End Sub

    Function Connect() As Boolean
        On Error GoTo 1
        Encrypt_Code = QQ.QQMd5.Encrypt(QQ_Number, QQ_Password, Verify_Code)    'Calculate the weird encrypt code
        With Http.HttpWebResponseUtility.CreateGetHttpResponse("http://ptlogin2.qq.com/login?u=" + QQ_Number + "&p=" + Encrypt_Code + "&verifycode=" + Verify_Code + "&webqq_type=10&remember_uin=1&login2qq=1&aid=1003903&u1=http%3A%2F%2Fweb2.qq.com%2Floginproxy.html%3Flogin2qq%3D1%26webqq_type%3D10&h=1&ptredirect=0&ptlang=2052&from_ui=1&pttype=1&dumy=&fp=loginerroralert&action=2-17-7145&mibao_css=m_webqq&t=1&g=1", -1, "", cookies)
            cookies.Add(.Cookies)
            Username = New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
            If Username.StartsWith("ptuiCB('0") Then
                Username = Username.Split(",")(5).Replace(");", "").Replace("'", "").Trim()
                ptwebqq = cookies("ptwebqq").Value
                Return True
            Else
                WebQQ_Interface._Error(Username)
                Return False
            End If
        End With
1:
        WebQQ_Interface._Error(Err.Description)
        Return False
    End Function

    Sub Logon()
        Dim Login_Info As IDictionary(Of String, String) = New Dictionary(Of String, String)()
        Dim Json_Login_str As String
        Login_Info.Add("r", "{" + Chr(34) + "status" + Chr(34) + ":" + Chr(34) + Chr(34) + "," + Chr(34) + "ptwebqq" + Chr(34) + ":" + Chr(34) + ptwebqq + Chr(34) + "," + Chr(34) + "passwd_sig" + Chr(34) + ":" + Chr(34) + Chr(34) + "," + Chr(34) + "clientid" + Chr(34) + ":" + Chr(34) + clientId + Chr(34) + "}")
        With Http.HttpWebResponseUtility.CreatePostHttpResponse("http://d.web2.qq.com/channel/login2", Login_Info, -1, "", System.Text.Encoding.UTF8, cookies, "http://d.web2.qq.com/proxy.html?v=20110331002&callback=1&id=3")
            cookies.Add(.Cookies)
            Json_Login_str = New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
        End With
        Dim Json_Login As Newtonsoft.Json.Linq.JObject = Newtonsoft.Json.JsonConvert.DeserializeObject(Json_Login_str)
        psessionid = Json_Login("result")("psessionid")
        vfwebqq = Json_Login("result")("vfwebqq")
    End Sub

    Function Wait_For_MSG() As String
        Try
            Dim Rec_Info As IDictionary(Of String, String) = New Dictionary(Of String, String)()
            Rec_Info.Add("r", "{" + Chr(34) + "clientid" + Chr(34) + ":" + Chr(34) + clientId + Chr(34) + "," + Chr(34) + "psessionid" + Chr(34) + ":" + Chr(34) + psessionid + Chr(34) + "," + Chr(34) + "key" + Chr(34) + ":0," + Chr(34) + "ids" + Chr(34) + ":[]}")
            Rec_Info.Add("psessionid", psessionid)
            Rec_Info.Add("clientid", clientId)
            With Http.HttpWebResponseUtility.CreatePostHttpResponse("http://d.web2.qq.com/channel/poll2", Rec_Info, -1, "", System.Text.Encoding.UTF8, cookies, "http://d.web2.qq.com/proxy.html?v=20110331002&callback=1&id=3")
                Return New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
            End With
        Catch ex As Exception
            WebQQ_Interface._Error(ex.Message)
            Return ""
        End Try
    End Function

    Function Get_Friend_List() As QQ_Friend_List
        On Error GoTo 1
        Dim Get_Friend_Info As IDictionary(Of String, String) = New Dictionary(Of String, String)()
        Dim Json_Friends_Str As String
        Get_Friend_Info.Add("r", My.Resources.Get_Friend1 + vfwebqq + My.Resources.Get_Friend2)
        With Http.HttpWebResponseUtility.CreatePostHttpResponse("http://s.web2.qq.com/api/get_user_friends2", Get_Friend_Info, -1, "", System.Text.Encoding.UTF8, cookies, "http://d.web2.qq.com/proxy.html?v=20110331002&callback=1&id=3")
            cookies.Add(.Cookies)
            Json_Friends_Str = New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
        End With

        Dim Json_Root As Newtonsoft.Json.Linq.JObject = Newtonsoft.Json.JsonConvert.DeserializeObject(Json_Friends_Str)
        If Json_Root("retcode") = "0" Then
            Dim Json_Result As Newtonsoft.Json.Linq.JObject = Json_Root("result")
            Dim Json_Friends As Newtonsoft.Json.Linq.JArray = Json_Result("friends")
            Dim Json_Categories As Newtonsoft.Json.Linq.JArray = Json_Result("categories")
            Dim Json_Info As Newtonsoft.Json.Linq.JArray = Json_Result("info")

            Dim Categories As New List(Of QQ_Friend_Categorie)
            Dim Default_Categorie As New QQ_Friend_Categorie With {.Index = 0, .Name = "My friends", .Sort = "0"}
            Categories.Add(Default_Categorie)
            For Each categ As Newtonsoft.Json.Linq.JObject In Json_Categories.Children
                Dim New_careg As New QQ_Friend_Categorie With {.Index = categ("index"), .Name = categ("name"), .Sort = categ("sort")}
                Categories.Add(New_careg)
            Next

            For i As Integer = 0 To Json_Friends.Count - 1
                For Each j As QQ_Friend_Categorie In Categories.ToArray
                    If j.Index = Json_Friends(i)("categories") Then
                        j.Friends.Add(Json_Info(i)("uin"), Json_Info(i)("nick"))
                    End If
                Next
            Next

            Dim r As New QQ_Friend_List
            r._str = Json_Friends_Str
            r.Friends.AddRange(Categories)
            Return r
        Else
            WebQQ_Interface._Error(Json_Friends_Str)
            Return Nothing
        End If
        Exit Function
1:
        WebQQ_Interface._Error(Err.Description)
        Return Nothing
    End Function

    Function Get_Group_list() As IDictionary(Of String, String)
        Dim r As IDictionary(Of String, String) = New Dictionary(Of String, String)()
        Try
            Dim Json_Group As String
            Dim Get_Group_Info As IDictionary(Of String, String) = New Dictionary(Of String, String)()
            Get_Group_Info.Add("r", "{" + Chr(34) + "vfwebqq" + Chr(34) + ":" + Chr(34) + vfwebqq + Chr(34) + "}")
            Get_Group_Info.Add("psessionid", psessionid)
            Get_Group_Info.Add("clientid", clientId)
            With Http.HttpWebResponseUtility.CreatePostHttpResponse("http://s.web2.qq.com/api/get_group_name_list_mask2", Get_Group_Info, -1, "", System.Text.Encoding.UTF8, cookies, "http://d.web2.qq.com/proxy.html?v=20110331002&callback=1&id=3")
                Json_Group = New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
            End With

            Dim Json_Root As Newtonsoft.Json.Linq.JObject = Newtonsoft.Json.JsonConvert.DeserializeObject(Json_Group)
            If Json_Root("retcode") = "0" Then
                Dim Json_Result As Newtonsoft.Json.Linq.JObject = Json_Root("result")
                Dim Json_gnamelist As Newtonsoft.Json.Linq.JArray = Json_Result("gnamelist")
                r.Clear()
                For Each group_item In Json_gnamelist.Children
                    r.Add(group_item("gid"), group_item("name"))
                Next
                Return r
            Else
                WebQQ_Interface._Error(Json_Group)
                Return Nothing
            End If
        Catch ex As Exception
            WebQQ_Interface._Error(ex.Message)
            Return Nothing
        End Try
    End Function

    Function Post_Complex_MSG(ByVal target As String, ByVal Messages As Newtonsoft.Json.Linq.JToken(), Optional ByVal IsGroup As Boolean = False, Optional ByVal MessageId As Integer = 3180000) As String
        On Error GoTo 1
        Dim s As String

        Dim Json_Root As New Newtonsoft.Json.Linq.JObject
        Dim Json_Content As New Newtonsoft.Json.Linq.JArray
        For Each i As Newtonsoft.Json.Linq.JToken In Messages
            Json_Content.Add(i)
        Next
        Json_Content.Add(WebQQ_Interface.Get_QQ_Font())
        Json_Root("content") = Json_Content.ToString
        If IsGroup Then Json_Root("group_uin") = target Else Json_Root("to") = target
        Json_Root("clientid") = clientId
        Json_Root("psessionid") = psessionid
        Json_Root("msg_id") = MessageId
        s = Json_Root.ToString
        s = System.Web.HttpUtility.UrlEncode(s, Text.Encoding.UTF8)
        Dim Rec_Info As IDictionary(Of String, String) = New Dictionary(Of String, String)()
        Rec_Info.Add("r", s)
        Rec_Info.Add("psessionid", psessionid)
        Rec_Info.Add("clientid", clientId)

        Dim Api As String
        If IsGroup Then Api = "http://d.web2.qq.com/channel/send_qun_msg2" Else Api = "http://d.web2.qq.com/channel/send_buddy_msg2"
        With Http.HttpWebResponseUtility.CreatePostHttpResponse(Api, Rec_Info, -1, "", System.Text.Encoding.UTF8, cookies, "http://d.web2.qq.com/proxy.html?v=20110331002&callback=1&id=3")
            Return New System.IO.StreamReader(.GetResponseStream()).ReadToEnd()
        End With
        Exit Function
1:
        WebQQ_Interface._Error(Err.Description)
    End Function

    Function Post_Text_MSG(ByVal target As String, ByVal Message As String, Optional ByVal IsGroup As Boolean = False, Optional ByVal MessageId As Integer = 3180000) As String
        Return Post_Complex_MSG(target, {New Newtonsoft.Json.Linq.JValue(Message)}, IsGroup, MessageId)
    End Function

    Function Analyse_QQMSG(ByVal Json_Value As Newtonsoft.Json.Linq.JObject, Optional ByVal From_Group As Boolean = False) As QQ_Message
        Dim QQMSG As New QQ_Message With {.msg_id = Json_Value("msg_id"),
                                          .from_uin = Json_Value("from_uin"),
                                          .to_uin = Json_Value("to_uin"),
                                          .msg_id2 = Json_Value("msg_id2"),
                                          .msg_type = Json_Value("msg_type"),
                                          .reply_ip = Json_Value("reply_ip"),
                                          .time = Json_Value("time"),
                                          .From_Group = From_Group}

        If QQMSG.From_Group Then
            QQMSG.group_code = Json_Value("group_code")
            QQMSG.send_uin = Json_Value("send_uin")
            QQMSG.seq = Json_Value("seq")
            QQMSG.info_seq = Json_Value("info_seq")
        End If

        Dim QQFont As New QQ_Font
        Dim Content_Array As Newtonsoft.Json.Linq.JArray = Json_Value("content")
        For Each Content_Item As Newtonsoft.Json.Linq.JToken In Content_Array.Children
            Select Case Content_Item.GetType.ToString
                Case GetType(Newtonsoft.Json.Linq.JArray).ToString
                    Select Case CType(Content_Item, Newtonsoft.Json.Linq.JArray)(0)
                        Case "offpic"
                            If CType(Content_Item, Newtonsoft.Json.Linq.JArray)(1)("success") = "1" Then QQMSG.Contents.Add(New QQ_Message_Content(CType(Content_Item, Newtonsoft.Json.Linq.JArray)(1)("file_path"), Content_Type.Picture))
                        Case "font"                                 'Font display part
                            Dim Json_Font As Newtonsoft.Json.Linq.JObject = CType(Content_Item, Newtonsoft.Json.Linq.JArray)(1)
                            QQFont.Size = Json_Font("size")
                            QQFont.Color = Json_Font("color")
                            QQFont.Style = Json_Font("style")
                            QQFont.Name = Json_Font("name")
                            QQMSG.Font = QQFont
                        Case "face"                                  'Face Part
                            Dim Face As String = CType(Content_Item, Newtonsoft.Json.Linq.JArray)(1)
                            QQMSG.Contents.Add(New QQ_Message_Content(Face, Content_Type.Face))
                    End Select
                Case GetType(Newtonsoft.Json.Linq.JValue).ToString   'Normal Text Part
                    QQMSG.Contents.Add(New QQ_Message_Content(Content_Item))
            End Select
        Next
        Return QQMSG
    End Function
#End Region

    Sub Listening_Thread_Proc()  'The listening process
        Do  'A infinite loop
            Dim QQ_Messages As New List(Of QQ_Message)
            Dim msg As String = Wait_For_MSG() 'Wait for the Message and them recieve it
            If msg <> "" Then
                If WebQQ_Interface.Polls_Arrive(msg) Then
                    'Start analysing this msg
                    Dim Json_Root As Newtonsoft.Json.Linq.JObject = Newtonsoft.Json.JsonConvert.DeserializeObject(msg) 'Decode the message

                    If Json_Root("retcode").ToString = "0" Then 'If there's an error
                        'No error
                        Dim Json_Results As Newtonsoft.Json.Linq.JArray = Json_Root("result")
                        For Each Json_Result As Newtonsoft.Json.Linq.JToken In Json_Results.Children 'Process each message
                            Dim Json_Value As Newtonsoft.Json.Linq.JObject = Json_Result("value")    'Grab its value
                            Select Case Json_Result("poll_type").ToString                            'Determine its type
                                Case "message"        'message from friend
                                    QQ_Messages.Add(Analyse_QQMSG(Json_Value))
                                Case "group_message"  'message from group
                                    QQ_Messages.Add(Analyse_QQMSG(Json_Value, True))
                                Case Else
                                    WebQQ_Interface._Ext_Poll_Proc(Json_Result)
                            End Select
                        Next
                    Else
                        'Error
                        WebQQ_Interface._Error(msg)
                    End If





                    'Raise On_QQ_Message_Arrive event
                    If QQ_Messages.Count > 0 Then
                        For Each m As QQ_Message In QQ_Messages.ToArray
                            If m.GetString().ToLower.StartsWith(CMD_Head + ".") Then
                                'Costum command
                                Dim cmd As String = m.GetString.Replace(vbLf, "").Replace(vbCr, "").Substring(CMD_Head.Length + 1).Split({" "c}, StringSplitOptions.RemoveEmptyEntries)(0)
                                Dim param As String = ""

                                Dim p As String = m.GetString.Substring(CMD_Head.Length + 1).Trim.Substring(cmd.Length)
                                Dim splited_cmd As String() = p.Split({" "c}, StringSplitOptions.RemoveEmptyEntries)

                                For Each i As String In splited_cmd
                                    param += i.Trim + " "
                                Next

                                param = param.Trim

                                If m.From_Group Then
                                    WebQQ_Interface.Command_Arrive(m.send_uin, m.from_uin, cmd, param)
                                Else
                                    WebQQ_Interface.Command_Arrive(m.from_uin, 0, cmd, param)
                                End If
                            Else
                                'Normal message
                                WebQQ_Interface.QQ_Message_Arrive(m)
                            End If
                        Next
                    End If
                End If
            End If
        Loop
    End Sub

    Sub Def_On_Command_Arrive(ByVal sender As String, ByVal group As String, ByVal cmd As String, ByVal Param As String)
        Dim targer As String
        If group = 0 Then targer = sender Else targer = group
        WriteLine("Command(" + WebQQ_Interface.Friend_List.Get_Name_From_Id(sender) + "): " + cmd + " " + Param)
        Select Case cmd.ToLower
            Case "admin"   'administrator logon
                If Param = CMD_Password And group = 0 Then
                    WebQQ_Interface.Administrator = sender
                    WebQQ_Interface.Send_Text_Message(targer, "You have become my master!", group)
                    WriteLine("Someone become the administrator: " + WebQQ_Interface.Friend_List.Get_Name_From_Id(sender))
                Else
                    WebQQ_Interface.Send_Text_Message(targer, "Wrong password!", group)
                    WriteLine("Someone input a incorrect administrator password: " + WebQQ_Interface.Friend_List.Get_Name_From_Id(sender))
                End If
            Case "stop"   'kill the robot
                If WebQQ_Interface.Administrator = sender Then
                    WebQQ_Interface.Quit()
                Else
                    WriteLine("A user try to stop the robot without authority: " + WebQQ_Interface.Friend_List.Get_Name_From_Id(sender))
                    WebQQ_Interface.Send_Text_Message(targer, "You don't have access to do this!", group)
                End If
            Case "about"  'show info about the AI platform
                WebQQ_Interface.Send_Text_Message(targer, "WebQQ AI Platform V0.99 Beta" + vbCrLf + "By 周行" + vbCrLf + "http://xiaocui.1x.net", group)
        End Select
    End Sub

    Sub Main()
        Console.Title = "QQ Robot By 周行（科创论坛金坷居士）"

        WriteLine("Loading configuration file.......")
        Load_Configuration()
        WriteLine()
        WriteLine("QQ_Number: " + QQ_Number)
        WriteLine("QQ_Password: " + QQ_Password)
        WriteLine("Administrator Password: " + CMD_Password)
        WriteLine()


        If AI_MainClass Is Nothing Then
            WriteLine("Could not load AI module, starts log on test mode...")
        Else
            WriteLine("AI Module: " + AI)
            WriteLine("AI initiallized!")
            If AI_MainClass.GetMethod("Init") IsNot Nothing Then WriteLine(AI_MainClass.GetMethod("Init").Invoke(Nothing, Nothing))
        End If


        WriteLine()
        WriteLine("Check Network Conditions.......")
        Check_Network()



        WriteLine("Getting Verify code......")
        Check_Verify_Code()
        WriteLine("Verify code: " + Verify_Code)
        WriteLine("Hexadecimal code: " + Hex_Code)
        WriteLine()


        WriteLine("Connecting......")
        If Not Connect() Then
            WriteLine(WebQQ_Interface.Last_Err)
            ReadLine()
            End
        End If

        WriteLine("ptwebqq: " + ptwebqq)
        WriteLine("uin: " + cookies("uin").Value)
        WriteLine("skey: " + cookies("skey").Value)
        WriteLine("Welcome! " + Username)
        WriteLine("Connection established!")
        WriteLine()



        WriteLine("Logging on......")
        Logon()
        WriteLine("psessionid: " + psessionid)
        WriteLine()
        WriteLine("Successfully log on!")



        WriteLine()
        WriteLine("Getting friend list...")
        Friend_List = Get_Friend_List()


        WriteLine()
        WriteLine("Getting group list...")
        Group_List = Get_Group_list()


        WriteLine()
        WriteLine("Start listening...")
        Listening_Thread.Start()

        WriteLine()
        WriteLine("Registing system command......")
        WriteLine("System command(A qq message send from a client or group,starts with '" + CMD_Head + ".' ,like: " + CMD_Head + ".about):")
        WriteLine("about - Show software info and help")
        WriteLine("admin - Get administrator access of the robot")
        WriteLine("stop - Kill the robot (administrator access needed)")

        AddHandler WebQQ_Interface.On_Command_Arrive, AddressOf Def_On_Command_Arrive

        WriteLine()
        If AI_MainClass IsNot Nothing Then
            WriteLine("Give the control to AI......")
        Else
            WriteLine("Finish log on test!")
        End If


        WriteLine("Press any key to quit......")
        ReadLine()
        End
    End Sub

 
End Module
